# SPDX-License-Identifier: AGPL-3.0-or-later
# Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
# Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
#
# DAMASK is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import shutil

import pytest
import numpy as np
import h5py

import damask

@pytest.fixture
def res_path(res_path_base):
    """Directory containing testing resources."""
    return res_path_base/'RGC'


def test_RGC_detect_changes(res_path,tmp_path,copy_files,h5py_dataset_iterator,assert_allclose,update):
    copy_files(res_path,tmp_path)
    load = 'tensionX'
    grid = '3grains3x3x3'
    material = 'material'
    job = f'{grid}_{load}'

    stdout,stderr = damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml -j {job}',
                                    wd=tmp_path)
    print(f'{stdout}\n{stderr}')

    if update:
        shutil.copy(tmp_path/f'{job}.hdf5',res_path)
    with h5py.File(res_path/f'{job}.hdf5','r') as ref, \
         h5py.File(tmp_path/f'{job}.hdf5','r') as cur:
        for (path,dset) in h5py_dataset_iterator(ref):
            if path.startswith('setup'): continue
            if len(dset.dtype) > 0:
                print(f'comparing {path}/{dset} (compound data type)')
                for e in dset.dtype.fields:
                    assert np.all(dset[e]==cur[path][e])
            else:
                print(f'comparing {path}/{dset}')
                atol=max(1e-8*max(np.amax(np.abs(dset)),np.amax(np.abs(cur[path]))),1e-12)
                assert_allclose(dset,cur[path],rtol=.0,atol=atol)
